
\name{s17dh}
\alias{s17dh}

\title{s17dh: Airy functions Bi(z) and Bi'(z), complex z}

\description{
s17dh returns the value of the Airy function \eqn{\mathrm{Bi}\left({z}\right)}{Bi(z)} 
or its derivative \eqn{{Bi}'\left({z}\right)}{Bi'(z)} for complex \eqn{{z}}{z}, 
with an option for exponential scaling.

}

\usage{
s17dh(deriv, z, scal)
}

\arguments{

\item{deriv}{string

Specifies whether the function or its derivative is required. 

\eqn{deriv=\mathtt{'F'}}{deriv='F'}: \eqn{\mathrm{Bi}\left({z}\right)}{Bi(z)} 
is returned.

\eqn{deriv=\mathtt{'D'}}{deriv='D'}: \eqn{{Bi}'\left({z}\right)}{Bi'(z)} 
is returned.




}
\item{z}{complex

The argument \eqn{{z}}{z} of the function.


}
\item{scal}{string

The scaling option. 

\eqn{scal=\mathtt{'U'}}{scal='U'}: The result is returned unscaled.

\eqn{scal=\mathtt{'S'}}{scal='S'}: The result is returned scaled by the 
factor \eqn{{e}^{{\mathrm{abs}(\mathrm{Re}\left({2}{z}  \sqrt{{z}} / 
{3}\right))}}}{e^abs(Re(2z  sqrt(z) / 3))}.




}
}

\details{
R interface to the NAG Fortran routine S17DHF.}

\value{

\item{BI}{complex

The required function or derivative value.


}
\item{IFAIL}{integer

\eqn{\mathrm{ifail} =0}{ifail =0} unless the function detects an error 
or a warning has been flagged (see the Errors section in Fortran library 
documentation).


}
}

\references{
\url{http://www.nag.co.uk/numeric/FL/nagdoc_fl23/pdf/S/s17dhf.pdf}
}

\author{NAG}

\examples{

ifail<-0

deriv<-'F'

z<-complex(1,0.3,0.4)

scal<-'U'

s17dh(deriv,z,scal)

}

\keyword{math}
\concept{airy}
\concept{Bi}
