
#include <R.h>
#include <Rinternals.h>
#include "nag_rwrapper_utils.h"
#include "nagmk23.h"
#ifdef __cplusplus
extern "C" {
#endif

#ifdef __cplusplus
}
#endif

/* Length of array to hold error messages, no checks are made to ensure this is large enough */
#define LEN_ERR_MSG 100

void A00ADF_clean_up(void);

SEXP WA00ADF()
{
  Integer IFAIL_integer;
  SEXP    ans, names;

/*initialization for output variables*/
  char    *IMPL_char = 0;
  Integer IMPL_length = 57;
  char    *PREC_char = 0;
  Integer PREC_length = 57;
  char    *PCODE_char = 0;
  Integer PCODE_length = 20;
  int     MKMAJ_integer;
  int     MKMIN_integer;
  char    *HDWARE_char = 0;
  Integer HDWARE_length = 64;
  char    *OPSYS_char = 0;
  Integer OPSYS_length = 64;
  char    *FCOMP_char = 0;
  Integer FCOMP_length = 64;
  char    *VEND_char = 0;
  Integer VEND_length = 64;
  Integer LICVAL_logical = 0;

/*allocation general variables*/
  if (!(IMPL_char = (char *) malloc(57*sizeof(char))))
    {
      error("Memory allocation error for %s", "IMPL");
    }
  if (!(PREC_char = (char *) malloc(57*sizeof(char))))
    {
      error("Memory allocation error for %s", "PREC");
    }
  if (!(PCODE_char = (char *) malloc(20*sizeof(char))))
    {
      error("Memory allocation error for %s", "PCODE");
    }
  if (!(HDWARE_char = (char *) malloc(64*sizeof(char))))
    {
      error("Memory allocation error for %s", "HDWARE");
    }
  if (!(OPSYS_char = (char *) malloc(64*sizeof(char))))
    {
      error("Memory allocation error for %s", "OPSYS");
    }
  if (!(FCOMP_char = (char *) malloc(64*sizeof(char))))
    {
      error("Memory allocation error for %s", "FCOMP");
    }
  if (!(VEND_char = (char *) malloc(64*sizeof(char))))
    {
      error("Memory allocation error for %s", "VEND");
    }

  /* Call the NAG routine */
  IFAIL_integer = 1;
  a00adf_(IMPL_char, PREC_char, PCODE_char, &MKMAJ_integer, &MKMIN_integer,
          HDWARE_char, OPSYS_char, FCOMP_char, VEND_char, &LICVAL_logical,
          IMPL_length,
          PREC_length, PCODE_length, HDWARE_length, OPSYS_length, FCOMP_length,
          VEND_length);

/* Get the list of results */
  PROTECT(ans = allocVector(VECSXP, 10));
  SET_VECTOR_ELT(ans, 0, nag_c2r(1, 57, 1, IMPL_char));
  SET_VECTOR_ELT(ans, 1, nag_c2r(1, 57, 1, PREC_char));
  SET_VECTOR_ELT(ans, 2, nag_c2r(1, 20, 1, PCODE_char));
  SET_VECTOR_ELT(ans, 3, nag_i2r(1, &MKMAJ_integer));
  SET_VECTOR_ELT(ans, 4, nag_i2r(1, &MKMIN_integer));
  SET_VECTOR_ELT(ans, 5, nag_c2r(1, 64, 1, HDWARE_char));
  SET_VECTOR_ELT(ans, 6, nag_c2r(1, 64, 1, OPSYS_char));
  SET_VECTOR_ELT(ans, 7, nag_c2r(1, 64, 1, FCOMP_char));
  SET_VECTOR_ELT(ans, 8, nag_c2r(1, 64, 1, VEND_char));
  SET_VECTOR_ELT(ans, 9, nag_l2r(1, &LICVAL_logical));
  /* Get names for the list of results */
  PROTECT(names = allocVector(STRSXP, 10));
  SET_STRING_ELT(names, 0, mkChar("IMPL"));
  SET_STRING_ELT(names, 1, mkChar("PREC"));
  SET_STRING_ELT(names, 2, mkChar("PCODE"));
  SET_STRING_ELT(names, 3, mkChar("MKMAJ"));
  SET_STRING_ELT(names, 4, mkChar("MKMIN"));
  SET_STRING_ELT(names, 5, mkChar("HDWARE"));
  SET_STRING_ELT(names, 6, mkChar("OPSYS"));
  SET_STRING_ELT(names, 7, mkChar("FCOMP"));
  SET_STRING_ELT(names, 8, mkChar("VEND"));
  SET_STRING_ELT(names, 9, mkChar("LICVAL"));
  setAttrib(ans, R_NamesSymbol, names);
/* Unprotect the ans and names objects */
  UNPROTECT(2);

/*Call the clean-up routine*/
  A00ADF_clean_up();

  return(ans);
}

void A00ADF_clean_up(void)
{
  return;
}
